//+------------------------------------------------------------------+
//|                                                  .mq4 |
//|                                                            Shuba |
//|                                              subinandrei@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Shuba"
#property link      "subinandrei@mail.ru"

extern int ZZper = 3;
extern string prefix = "vibr_"; //    
double ZZ0UP, ZZ1UP, ZZ2UP, ZZ0DW, ZZ1DW, ZZ2DW;
int ZZ0upB, ZZ1upB, ZZ2upB, ZZ0dwB, ZZ1dwB, ZZ2dwB;
double t1,t2,t3;
int P, B, Real;
int Pt;
double Bt;
double M;
double T;
datetime Tt;
int tm1,tm2,tm3;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Comment ("");
  for(int i = ObjectsTotal()-1; i >= 0; i--)  //     
      if(StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)//  ..
                                                   // ..  ,  
                                                   // ..prefix, ..
        ObjectDelete(ObjectName(i));           // ..   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
//----
  ZZ();
  Middle(prefix + "1",prefix + "2");
//----
   if(ZZ0upB < ZZ0dwB) 
     {
     SetTLine(GreenYellow, prefix + "1",Time[ZZ2upB], High[ZZ2upB], Time[ZZ0dwB], Low[ZZ0dwB]);
     SetTLine(GreenYellow, prefix + "2", Time[ZZ1dwB], Low[ZZ1dwB], Time[ZZ1upB], High[ZZ1upB]); 
     }
   if(ZZ0dwB < ZZ0upB) 
     {
     SetTLine(GreenYellow, prefix + "1", Time[ZZ2dwB], Low[ZZ2dwB], Time[ZZ0upB], High[ZZ0upB]);
     SetTLine(GreenYellow, prefix + "2", Time[ZZ1dwB], Low[ZZ1dwB], Time[ZZ1upB], High[ZZ1upB]); 
     }
   
  SetHLine(Red, prefix + "3", M); 

//----
   return(0);
  }
//+------------------------------------------------------------------+


//+----------------------------------------------------------------------------+
//|      :  . aka Shuba,  subinandrei@mail.ru                       |
//+----------------------------------------------------------------------------+
//|     : 21.03.2012                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    nm1 -                                                     |
//|    nm2 -                                                     |
//|    :                        |
//+----------------------------------------------------------------------------+
void Middle(string nm1,string nm2)
  {
  //double M;
  double x1, x2, x3, x4;
  double y1, y2, y3, y4;
  double k1, k3;
  
  if(ObjectFind(nm1)==0 && ObjectFind(nm2)==0)
    {
    y1=ObjectGet(nm1, OBJPROP_PRICE1);
    y2=ObjectGet(nm1, OBJPROP_PRICE2);
    x1=ObjectGet(nm1, OBJPROP_TIME1);
    x2=ObjectGet(nm1, OBJPROP_TIME2);
    
    y3=ObjectGet(nm2, OBJPROP_PRICE1);
    y4=ObjectGet(nm2, OBJPROP_PRICE2);
    x3=ObjectGet(nm2, OBJPROP_TIME1);
    x4=ObjectGet(nm2, OBJPROP_TIME2);
    
    k1=(y2-y1)/(x2-x1); 
    k3=(y4-y3)/(x4-x3);
    
    if(k1 != k3)
      {
      T = (y1 - y3 + k3*x3 - k1*x1)/(k3 - k1);
      M = y1 + k1*(T - x1);
      Tt = T;
      }
    }
  return(0);
  }
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   OBJ_TREND                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                (  ""  -    )  |
//|    t1 -           (  0   - Time[10]                       |
//|    p1 -              (  0   - Low[10])                       |
//|    t2 -           (  0   -  )                   |
//|    p2 -              (  0   - Bid)                           |
//|    ry -                         (False -  )                  |
//|    st -                  (  0   -  )                 |
//|    wd -                 (  1   -  )                  |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}


//+----------------------------------------------------------------------------+
void ZZ()
  {
//----  
  ZZ0UP = NormalizeDouble(GetExtremumZZPrice(0, 0),Digits);
  ZZ0upB = GetExtremumZZBar(0, 0);
  
  ZZ1UP = NormalizeDouble(GetExtremumZZPrice(0, 1),Digits);
  ZZ1upB = GetExtremumZZBar(0, 1);
  
  ZZ2UP = NormalizeDouble(GetExtremumZZPrice(0, 2),Digits);
  ZZ2upB = GetExtremumZZBar(0, 2);
//----  
  ZZ0DW = NormalizeDouble(GetExtremumZZPrice(1, 0),Digits);
  ZZ0dwB = GetExtremumZZBar(1, 0);
  
  ZZ1DW = NormalizeDouble(GetExtremumZZPrice(1, 1),Digits);
  ZZ1dwB = GetExtremumZZBar(1, 1);
  
  ZZ2DW = NormalizeDouble(GetExtremumZZPrice(1, 2),Digits);
  ZZ2dwB = GetExtremumZZBar(1, 2);
//----
  }
//+------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :        .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    ma_period -                                                     |
//|    ne -             (      0     - )               |
//+----------------------------------------------------------------------------+
int GetExtremumZZBar(int pic, int ne=0) {
  
  double zz;
  int    i, k=iBars(NULL, 0), ke=0;

  for (i=0; i<k; i++) {
    zz=iCustom(NULL,0,"rvmGann_sv8", ZZper, pic, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(i);
    }
  }
  Print("GetExtremumZZBar():    ",ne,"  ");
  return(-1);
}

//+-------------------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :      .                    |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    ma_period -                                                     |
//|    ne -             (      0     - )               |
//+----------------------------------------------------------------------------+
double GetExtremumZZPrice(int pic, int ne=0) {
  
  double zz;
  int    i, k=iBars(NULL, 0), ke=0;

  for (i=1; i<k; i++) {
    zz=iCustom(NULL,0,"rvmGann_sv8",  ZZper, pic, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(zz);
    }
  }
  Print("GetExtremumZZPrice():    ",ne,"  ");
  return(0);
}
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 30.03.2008                                                     |
//|   :   OBJ_HLINE                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                ("" -    )     |
//|    p1 -              (0  - Bid)                              |
//|    st -                  (0  -  )                    |
//|    wd -                 (0  -  )                     |
//+----------------------------------------------------------------------------+
void SetHLine(color cl, string nm="", double p1=0, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (p1<=0) p1=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_HLINE, 0, 0,0);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}
//+----------------------------------------------------------------------------+


